#pragma once

//#define USE_IMU
//#define USE_BARO
#define USE_MAG

#include "bmi088.h"
#include "ms5611.h"
#include "bm1422.h"


typedef struct {
  unsigned timestamp;
  unsigned duration;
  unsigned segment_a;
  unsigned segment_b;
  unsigned segment_c;
  unsigned segment_d;
  unsigned segment_e;
  unsigned segment_f;
  unsigned segment_g;
  unsigned segment_h;

  bmi088_data_raw_t imu_a_raw_data;
  bmi088_data_raw_t imu_b_raw_data;
  bmi088_data_t imu_a_data;
  bmi088_data_t imu_b_data;
  float temperature_a;
  float temperature_b;
  float pressure_a;
  float pressure_b;
  bm1422_raw_t mag_a;
  bm1422_raw_t mag_b;
} flight_sensors_data_t;

void flight_sensors_setup();
// Due to some sensor behavior it's required to feed in the previous reading
// to ensure consistent timing.
flight_sensors_data_t flight_sensors_read_data(flight_sensors_data_t* previous);
