#include "canbus.h"
#include "flight_sensors.h"

#include <stdio.h>
#include <propeller2.h>

enum { _clkfreq = 200_000_000, _xtlfreq = 20_000_000 };

#define TRIGGER_PIN 35
#define PHASE_PIN 34

void main() {
  _setbaud(2_000_000);
  _pinl(TRIGGER_PIN);
  //can_start();
  flight_sensors_setup();
  unsigned last_timestamp = 0;
  unsigned min_duration = 0xffffffff;
  flight_sensors_data_t data = flight_sensors_read_data(NULL);
  for(;;) {
    _pinh(PHASE_PIN);
    data = flight_sensors_read_data(&data);
    _pinl(PHASE_PIN);
    printf("duration: %d\n", data.duration);
    if(min_duration > data.duration)
    {
      min_duration = data.duration;
    }
    if(data.duration > 2 * min_duration)
    {
      _pinh(TRIGGER_PIN);
      if(last_timestamp)
      {
        printf("cycletime: %f\n", (float)(data.timestamp - last_timestamp) / 200_000_000.0);
        printf("a:%d,b:%d,c:%d,d:%d,e:%d,f:%d,g:%d,h:%d,\n", data.segment_a, data.segment_b,data.segment_c, data.segment_d,data.segment_e, data.segment_f,data.segment_g, data.segment_h);
      }
      last_timestamp = data.timestamp;
      _pinl(TRIGGER_PIN);
    }
    //printf("x:%d,y:%d,z:%d\n", data.mag_b.x, data.mag_b.y, data.mag_b.z);
    _waitms(100);
  }
}
